package grammar;

import json.GrammarToJSON;
import type3.Type3GrammarGenerator;

public class Type3Grammar extends Grammar {

	Type3GrammarGenerator g = new Type3GrammarGenerator();

	public Type3Grammar(String[] vars, int alphaSize, String start, int maxConclusios, int mode) {
		super(vars, alphaSize, start);
		switch (mode) {
		case 0:
			this.setRules(g.genType3GrammarRuleSet0(vars, alphaSize, maxConclusios, start));
			break;
		case 1:
			this.setRules(g.genType3GrammarRuleSet1(vars, alphaSize, maxConclusios, start));
			break;
		case 2:
			this.setRules(g.genType3GrammarRuleSet2(vars, alphaSize, maxConclusios, start));
			break;
		case 3:
			this.setRules(g.genType3GrammarRuleSet3(vars, alphaSize, maxConclusios, start));
			break;
		default:
			break;
		}
	}

	@Override
	public String toJSON() {
		return GrammarToJSON.createJSONGrammar(this);
	}

}
